import { float64, Node, Node3D, NodePath, PackedStringArray, Variant } from 'godot'
import { Damageable } from './health'
import { export_ } from 'godot.annotations'

export default class DamageSource extends Node3D {
  @export_(Variant.Type.TYPE_FLOAT)
  amount: float64 = 0

  @export_(Variant.Type.TYPE_NODE_PATH)
  source = new NodePath('.')
  _source_node!: Node

  _ready(): void {
    this._source_node = this.get_node(this.source)
  }

  damage_target(target: Damageable) {
    target.apply_damage(this._source_node, this.amount)
  }
}

